const puppeteer = require("puppeteer");
const sleep = require("sleep-promise");
const fs = require("fs");

const chromiumPath =
  "C:\\Users\\zohren\\AppData\\Local\\Chromium\\Application\\chrome.exe";
const botDisplayName = "Puppet";
const bbbUrl = "https://bbb.fachschaften.org";
const roomUrl = "https://bbb.fachschaften.org/b/jon-kmr-9gk";
const username = "tudo-fsinfo-fsr-bot";
const password = "S4VKuhkASUWsTgL8";

(async () => {
  const browser = await puppeteer.launch({
    headless: false,
    executablePath: chromiumPath,
    defaultViewport: {
      width: 1200,
      height: 600,
      isLandscape: true,
    },
  });
  const context = await browser.createIncognitoBrowserContext();

  const page = await context.newPage();
  const authenticatedPage = await signIn(bbbUrl, username, password, page);
  await joinRoom(authenticatedPage, roomUrl, botDisplayName);
  await sendChatMessage(authenticatedPage, "I am a text");
  await sleep(6000);
  await screenShotPresentationArea(authenticatedPage);

  //const authenticatedPage = await signIn(bbbUrl, username, password, page);

  /*
  const rooms = await listUsersRooms(authenticatedPage);
  console.debug(rooms);
  await fs.promises.writeFile("rooms.json", JSON.stringify(rooms));
  */

  /*
  for (let i = 1; i <= 5; i++) {
    await createRoom(authenticatedPage, {
      name: "🚧 Gruppe " + i,
      access_code: "",
      mute_on_join: false,
      require_moderator_approval: false,
      anyone_can_start: true,
      all_join_moderator: false,
    });
    console.log("Created room", i);
    await sleep(500);
  }
  */

  await sleep(120 * 1000);
  console.log("Done. Screenshotting and closing.");
  await authenticatedPage.screenshot({ path: "example.png" });

  await browser.close();
})();

async function joinRoom(page, roomUrl, displayName = "Puppet") {
  await page.goto(roomUrl);
  console.log("joinRoom > Gone to start page for", roomUrl);

  // Set displayname for program
  await page.type("input.join-form", displayName);

  // Join and load room
  await page.click("button#room-join");
  await sleep(4000);

  console.log("joinRoom > Joined room as", displayName);

  // Click audio choice panel away
  await page.click('button[aria-describedBy="modalDismissDescription"]');

  console.log("joinRoom > clicked audio choice away.");
  return page;
}

async function sendChatMessage(page, messageText) {
  const chatInputHandle = await page.$("textarea#message-input");
  const chatSendButtonHandle = await page.$(
    'form > div > button[type="submit"]'
  );

  // Send a text message
  await chatInputHandle.type(messageText);
  await chatSendButtonHandle.click();
  console.log("sendChatMessage > sent Message");
}

async function signIn(bbbUrl, username, password, page = null) {
  // Create page if not done already
  if (page === null) {
    const browser = await puppeteer.launch({
      headless: false,
      executablePath: chromiumPath,
    });
    page = await browser.newPage();
  }

  await page.goto(bbbUrl);

  await page.waitForSelector("a.sign-in-button");
  const signInButton = await page.$("a.sign-in-button");
  if (signInButton === null) {
    console.log(
      "SignIn > Can't find sign-in button: User is probably already authenticated."
    );
    return page;
  }

  await page.click("a.sign-in-button");
  await page.waitForNavigation();
  console.log("SignIn > NAVIGATED TO LOGIN PAGE");

  await page.type("input#session_username", username);
  await page.type("input#session_password", password);
  await page.click("input.signin-button");
  console.log("SignIn > entered credentials");

  await page.waitForNavigation();
  console.log("SignIn > Probably logged in.");

  return page;
}

async function listUsersRooms(authenticatedPage) {
  const listDiv = await authenticatedPage.$("div#room_block_container");

  await sleep(500);

  const roomBlockHandles = await listDiv.$$("div.room-block");

  let rooms = [];
  for (let roomBlockHandle of roomBlockHandles) {
    // Get room blocks
    const attributes = await roomBlockHandle.evaluate((node) => ({
      path: node.getAttribute("data-path"),
      accessCode: node.getAttribute("data-room-access-code"),
      uid: node.getAttribute("data-room-uid"),
      settings: node.getAttribute("data-room-settings")
        ? JSON.parse(node.getAttribute("data-room-settings"))
        : null,
    }));

    // Fix room uid
    attributes.uid = attributes.uid
      ? attributes.uid
      : attributes.path.split("/")[2];

    // Read room names
    const roomName = await (await roomBlockHandle.$("div > h4")).evaluate(
      (node) => node.innerText
    );

    // Read room ownership
    const isSharedRoom = (
      await (await roomBlockHandle.$("span.stamp > i.fas")).evaluate((node) =>
        node.getAttribute("class")
      )
    ).includes("fa-share-alt");

    // Get room settings
    const { settings, sharedWith } = await authenticatedPage.evaluate(
      async (roomUid, pageUrl) => {
        const urlparts = pageUrl.split("/");
        const roomPreUrl = urlparts[0] + "//" + urlparts[2] + "/b/" + roomUid;
        return {
          settings: await (await fetch(roomPreUrl + "/room_settings")).json(),
          sharedWith: await (await fetch(roomPreUrl + "/shared_users")).json(),
        };
      },
      attributes.uid,
      authenticatedPage.url()
    );

    const roomData = {
      ...attributes,
      name: roomName,
      sharedRoom: isSharedRoom,
      settings,
      sharedWith,
    };
    // Save to room list
    rooms.push(roomData);
  }

  return rooms;
}

async function createRoom(authenticatedPage, roomSettings) {
  const pageUrl = await authenticatedPage.url();
  const urlparts = pageUrl.split("/");
  const url = urlparts[0] + "//" + urlparts[2];
  const authenticityTokenHandle = await authenticatedPage.$(
    'input[name="authenticity_token"]'
  );
  const authenticityToken = await authenticityTokenHandle.evaluate(
    (node) => node.value
  );

  await authenticatedPage.evaluate(
    async (url, authenticityToken, roomSettings) => {
      function urlencodeFormData(fd) {
        var s = "";
        function encode(s) {
          return encodeURIComponent(s).replace(/%20/g, "+");
        }
        for (var pair of fd.entries()) {
          if (typeof pair[1] == "string") {
            s += (s ? "&" : "") + encode(pair[0]) + "=" + encode(pair[1]);
          }
        }
        return s;
      }

      // Prepare form data
      const form = new FormData();
      form.set("utf8", "✓");
      form.set("authenticity_token", authenticityToken);
      for (const key of Object.keys(roomSettings)) {
        // Maybe fix this, because the POST format is weird
        if (typeof roomSettings[key] === "boolean") {
          form.append("room[" + key + "]", 0);
          if (roomSettings[key]) {
            form.append("room[" + key + "]", 1);
          }
        } else {
          form.set("room[" + key + "]", roomSettings[key]);
        }
      }
      form.set("room[auto_join]", "0");
      form.set("commit", "Create+Room");

      try {
        // Send request to create room
        const response = await fetch(url, {
          method: "POST",
          headers: {
            "Content-Type": "application/x-www-form-urlencoded",
          },
          redirect: "follow", // manual, *follow, error
          body: urlencodeFormData(form),
        });
        return response;
      } catch (error) {
        return error;
      }
    },
    url + "/b",
    authenticityToken,
    roomSettings
  );

  await authenticatedPage.goto(url);
}

async function screenShotPresentationArea(authenticatedPage) {
  console.log("takeScreenshot > starting...");
  const presentationAreaHandle = await authenticatedPage.$("div#container");
  presentationAreaHandle.screenshot({ path: "room.png" });
}
